#include "memory.h"
#include "function.h"
#include "compile.h"
#include "colon-state.h"

C( P: &var -- )
static void load_constant(void)
{
  op_t *op;
  varbl *var;
  var = ppop();
  
  op = allocate(sizeof(op_t));
  op->opcode = SET;
  op->r1 = var->reg;
  op->r2 = ZERO;
  op->value = var->u;
  ppush(op);
  VVappend_def();
}

C( P: &var -- )
static void save_dummy(void) /* constants don't save */
{
  varbl *var;
  var = ppop();
}

C( P: &arg_t &var -- )
static void preserve_dummy(void)  /* constants don't preserve */
{
  varbl *var;
  arg_t *arg;
  var = ppop(); arg = ppop();

  /* variables that preserve as random variables are automatically preserved */

  arg->type = RANDOM_REG;
  arg->arg.gn.data1 = 0;
  arg->arg.gn.data2 = 0;
}

void VVget_constant(void)  C( value -- ) C( P: -- &varbl)
{
  uval data;
  data = dpop();
  
  ppush(&load_constant);
  ppush(&save_dummy);
  ppush(&preserve_dummy);
  ppush(0);
  dpush(data); /* did I need to pop it? */
  VVnew_var();
}

C( P: &var -- )
static void load_dummy(void) /* dummies don't even load */
{
  varbl *var;
  var = ppop();
}

C( P: -- &varble ) C( id -- )
void VVget_dummy(void)
{
  static uval sequence_number = 0; /* make all dummyes distinct */
  /* but then I can't get them again, oh, well */
  uval id;
  id = dpop();
  ppush(&load_dummy);
  ppush(&save_dummy);
  ppush(&preserve_dummy);
  ppush(0);
/*  dpush(sequence_number++); */
  dpush(id);
  VVnew_var();
}
