#include "throf.h"
#include "memory.h"
#include "compile.h"
#include "function.h"
#include "colon-globals.h"
#include "colon-state.h"
#include "colon-stack.h"

C( P: &var -- )
static void save_global(void)
{
  op_t *op;
  varbl *var;

  var = ppop();

  op = allocate(sizeof(op_t));
  op->opcode = STORE;
  op->value = (uval)(((uchar*)var->v) + var->u);
  op->r1 = ZERO;
  op->r2 = var->reg;
  ppush(op);
  VVappend_def();
}

C( &var -- )
static void load_global(void)
{
  op_t * op;
  varbl *var;

  var = ppop();

  op = allocate(sizeof(op_t));
  op->opcode = LOAD;
  op->value = (uval)(((uchar*)var->v) + var->u);
  op->r1 = var->reg;
  op->r2 = ZERO;
  ppush(op);
  VVappend_def();
}

C( P: &arg_t &var -- )
static void preserve_global(void)
{
  arg_t *arg;
  varbl *var;
  var = ppop(); arg = ppop();
  arg->type = GLOBAL_REG;
  arg->arg.gr.variable = var->v;
  arg->arg.gr.offset = var->u;
}

C( P: &global_var -- &varbl )  C( offset -- )
void VVget_global(void)
{
  uchar *addr;
  uval offset;

  addr = ppop(); offset = dpop();

  /* this is a hack, repeat this is a hack */
  /* it simply allows me to alias my stack pointer as globals */
  /* unless I make this more general this is not a clean way to go */

  if (addr+offset == (uchar*)&dstack.place_pushed) 
    { ppush(&dstack); VVget_stack(); }
  else if (addr+offset == (uchar *)&rstack.place_pushed)
    { ppush(&rstack); VVget_stack(); }
  else if (addr+offset == (uchar *)&fstack.place_pushed)
    { ppush(&fstack); VVget_stack(); }
  else if (addr+offset == (uchar *)&pstack.place_pushed)
    { ppush(&pstack); VVget_stack(); }
  else
    {
      ppush(&load_global);  
      ppush(&save_global);  
      ppush(&preserve_global);
      dpush(offset); ppush(addr);  VVnew_var();
    }
}

