#ifndef COLON_STATE_H
#define COLON_STATE_H

#include "compile.h"
#include "colon-variable.h"

typedef struct colon_state {
  word_t current_definition;
  op_t *last;
  reg_state rstate;
  struct stack_state * first_stack;
  struct colon_state * prev;
}colon_state;

void VVget_state(void);      C( P: -- &colon_state )
void VVnest_state(void);     C( -- )
void VVunnest_state(void);   C( -- )
void VVappend_def(void);     C( P: &op_t -- )

void VVnew_var(void);        C( P: &load &save &preserve v  -- &varbl) C( u -- )
void VVvar_reg(void);        C( P: &var -- )  C( -- reg )
void VVassign_var(void);     C( P: &var -- )  C( reg -- )
void VVrelease_var(void);    C( P: &var -- )
void VVtransfer_var(void);   C( P: &var_from &var_to -- )
void VVinvalidate_var(void); C( P: &var -- )
void VVinvalidate_all(void); C( -- )
void VVvar_in_reg(void);     C( P: &var -- ) C( reg -- )
void VVreg_state(void);      C( P: -- &arg_array )
void VVvar_for_reg(void);    C( reg -- ) C( P: -- &varbl )
void VVflush_var(void);      C( P: &varbl -- )

#endif /* COLON_STATE_H */
