#ifndef COLON_VARIABLE_H
#define COLON_VARIABLE_H

#ifndef C
#define C(X) 
#endif

#include "function.h"

#if 0
/* this file coordinates getting a local variable */
/* this should enable me to keep things in registers etc. */
/* and it should handle spilling of local variables to the return stack */

/* also it should enable locals to change registers transparently */
void VVget_variable(void);      /* get a (local) variable */
void VVassign_variable(void);   /* assign a (local) variable to a specific register */
void VVreg_for_variable(void);  /* get the register a (local) variable is in */

void VVinitial_variables(void); /* what are the initial (local) variable assignments */
void VVfinal_variables(void);   /* what are the final local variable assignments */
void VVmatch_variables(void);   /* match up locals with the current assignments, for a function call */
struct stack_var {
  struct stack_data *stack;
  uval offset;  /* stack offset from the top of the stack */
  reg_t reg;
};
struct global_var {
  ref variable;
  uval offset;
  reg_t reg;
};
#endif

/* if I add any more flags I must update all references */
typedef enum var_flags 
{ safe_to_flush = 1, flushed = 2, safe_to_move = 4, safe_to_remove = 8 } var_flags;

typedef void(*variable_method)(void);

typedef struct variable {
  var_flags flags;
  reg_t reg;
  variable_method load;      C( P: &var -- ) /* expected to load the variable into the register */
  variable_method save;      C( P: &var -- ) /* expected to save the variable in the register */
  variable_method preserve;  C( P: &arg_t &var -- ) /* expected to save the state in arg_t */
  uval u;  /* reserved for use by the implementors of load & save */
  void *v;
}varbl;

typedef struct var_node {
  struct variable var;  /* this must be the first member */
  struct var_node *next;
  struct var_node *prev;
}var_node;

typedef struct reg_state {
  var_node *var_list;
  varbl *regs[MAX_REG];
}reg_state;

varbl * new_variable(reg_state *state, variable_method load,
		     variable_method save, variable_method preserve, uval u, void* v);
reg_t reg_for_variable(reg_state *state, varbl *var);
void assign_variable(reg_state *state, varbl *var, reg_t reg);
void release_variable(reg_state *state, varbl *var);
void transfer_value(reg_state *state, varbl *from, varbl *to);

void flush_variable(reg_state *state, varbl *var);
void invalidate_variable(reg_state *state, varbl *var);
void init_state(reg_state *state);
void invalidate_all(reg_state *state);
void in_variable(reg_state *state, varbl *var, reg_t reg);
arg_array *get_register_state(reg_state *state);

#endif COLON_VARIABLE_H
