#ifndef DICTIONARY_H
#define DICTIONARY_H

#include "throf.h"
#include "function.h"

typedef enum function_flags { IMM = 1 } func_flags_t;

typedef struct function_entry {
  unsigned name_len;
  char *name;
  func_flags_t flags;
  func_t *execution;        /* I probably only want execution & compilation! */
}entry;

typedef struct function_info_tree_node {
  struct function_entry entry;
  struct function_info_tree_node * less;
  struct function_info_tree_node * greater;
}func_node;

entry * find_func(char * str,unsigned str_len);

entry *register_func(char *name, unsigned name_len, func_t *func, func_flags_t flags);

void register_function(char * name, unsigned name_len, func_ptr_t func, 
		       func_flags_t flags,
		       arg_array *arg, arg_array *ret);

#endif


