#ifndef STACK_H
#define STACK_H

#include "throf.h"
#include "spaghetti-stack.h"

#undef C_STACK

extern stack_data dstack;
extern stack_data pstack;
extern stack_data fstack;
extern stack_data rstack;

void dpush(uval val);
uval dpop(void);
uval dpeek(uval place);
uval ddepth(void);
void droll(uval place);

void ppush(ref val);
ref  ppop(void);
ref  ppeek(uval place);
uval pdepth(void);
void proll(uval place);

void fpush(real val);
real fpop(void);
real fpeek(uval place);
uval fdepth(void);

void rpush(uval val);
uval rpop(void);
uval rpeek(uval place);
uval rdepth(void);

/* this routine doesn't return until the program terminates,
   basically never.  the_rest is called to continue execution
 */
void init_stacks(void (*the_rest)(void));
void sync_return_stack(void);

#define RSTACK_DIR down
#endif /* STACK_H */

