#ifndef THROF_H
#define THROF_H

/* this is my way of implementing forth stack comments :) */
#ifndef C
#define C(X)
#endif

typedef unsigned long uval;
typedef signed long   sval;
typedef void *        ref;
typedef double        real;
typedef uval          flag;
typedef unsigned char uchar;
typedef signed   char schar;

typedef unsigned long long udval;
typedef signed   long long sdval;

typedef enum boolean {false = 0, true = 0xFFFFFFFF} boolean;

#define UVAL_BITS 32
#define UVAL_MIN  0
#define UVAL_MAX ((uval)0xFFFFFFFF)
#define SVAL_MAX ((sval)0x7FFFFFFF)
#define SVAL_MIN ((sval)0x80000000)
#define FALSE  (0)
#define TRUE   (0xFFFFFFFFUL)

#define NIL 0   /* this doesn't have to be the C null pointer, it's a forth null pointer :) */

/* these are C implementation dependent! */
#define UTOP(X) ((void *)(X))
#define STOP(X) ((void *)(X))
#define PTOU(X) ((uval)(X))
#define PTOS(X) ((sval)(X))

#define DISABLE_STACK_CONTINUATIONS 1
#define RETURN_STACK_STUCK 1  /* in esp */

#endif /* THROF_H */
